package com.docus.server.controller;

import com.docus.core.util.json.JSON;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.api.scheduling.management.SchCollectRecordApi;
import com.docus.server.common.MsgConstants;
import com.docus.server.dto.scheduling.management.schcollector.task.SchCollectorTaskDTO;
import com.docus.server.dto.scheduling.management.schcollectrecord.AddSchCollectRecordDTO;
import com.docus.server.dto.scheduling.management.schcollectrecord.DeleteSchCollectRecordDTO;
import com.docus.server.dto.scheduling.management.schcollectrecord.EditSchCollectRecordDTO;
import com.docus.server.dto.scheduling.management.schterminator.CommMsgDTO;
import com.docus.server.service.ICommMsgService;
import com.docus.server.service.ISchCollectRecordService;
import com.docus.server.vo.scheduling.management.schcollectrecord.SchCollectRecordVO;
import com.fasterxml.jackson.core.type.TypeReference;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 采集记录表 控制器类
 *
 * @author AutoGenerator
 * @since 2023-07-15
 */
@RestController
public class SchCollectRecordController implements SchCollectRecordApi {
    @Resource
    private ISchCollectRecordService iSchCollectRecordService;
    @Resource
    private ICommMsgService iCommMsgService;

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchCollectRecordVO findById(String id) {
        String s = "{\n" +
            "\t\"taskInfo\": {\n" +
            "\t\t\"createTime\": \"2022-12-03 12:39:30\",\n" +
            "\t\t\"hospitals\": [{\n" +
            "\t\t\t\"admissDate\": \"2023-12-31 01:01:01\",\n" +
            "\t\t\t\"admissId\": \"amid_999901\",\n" +
            "\t\t\t\"admissTimes\": 1,\n" +
            "\t\t\t\"disDate\": \"2023-12-31 01:01:01\",\n" +
            "\t\t\t\"disDeptName\": \"22222\",\n" +
            "\t\t\t\"patientId\": \"758878610105573376\"\n" +
            "\t\t}],\n" +
            "\t\t\"jzh\": \"jzh_999901\",\n" +
            "\t\t\"patient\": {\n" +
            "\t\t\t\"inpatientNo\": \"999901\",\n" +
            "\t\t\t\"name\": \"ceshi\",\n" +
            "\t\t\t\"patientId\": \"758878610105573376\"\n" +
            "\t\t},\n" +
            "\t\t\"patientId\": \"758878610105573376\",\n" +
            "\t\t\"recordType\": \"1\",\n" +
            "\t\t\"tasks\": [{\n" +
            "\t\t\t\"collectorId\": \"1\",\n" +
            "\t\t\t\"patientId\": \"758878610105573376\",\n" +
            "\t\t\t\"taskId\": \"834292710565826560\"\n" +
            "\t\t}]\n" +
            "\t},\n" +
            "\t\"collectorRecordId\": \"123\",\n" +
            "\t\"isRetry\": 0\n" +
            "\n" +
            "}";
        SchCollectorTaskDTO schCollectorTaskDTO = JSON.fromJSONWithGeneric(s, new TypeReference<SchCollectorTaskDTO>() {
        });

        CommMsgDTO commMsgDTO = CommMsgDTO.builder()
            .content(JSON.toJSON(schCollectorTaskDTO))
            .messageType(MsgConstants.SCH_DISTRIBUTE_TASKS)
            .build();

        iCommMsgService.clientsCommand(commMsgDTO);
        return iSchCollectRecordService.findById(id);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchCollectRecordVO> search(SearchDTO searchDTO) {
        return iSchCollectRecordService.search(searchDTO);
    }

    /**
     * 新增
     *
     * @param addSchCollectRecordDTO 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(AddSchCollectRecordDTO addSchCollectRecordDTO) {
        return iSchCollectRecordService.add(addSchCollectRecordDTO);
    }

    /**
     * 编辑
     *
     * @param editSchCollectRecordDTO 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(EditSchCollectRecordDTO editSchCollectRecordDTO) {
        return iSchCollectRecordService.edit(editSchCollectRecordDTO);
    }

    /**
     * 批量删除
     *
     * @param deleteSchCollectRecordDTO 删除参数
     * @return 成功或失败
     */
    @Override
    public int delete(DeleteSchCollectRecordDTO deleteSchCollectRecordDTO) {
        return iSchCollectRecordService.delete(deleteSchCollectRecordDTO);
    }
}
